!-------------------------------------BOF---------------------------------------

!-------------------------------------------------------------------------------
!     UMESHMOTION
!-------------------------------------------------------------------------------

      subroutine umeshmotion(uref,ulocal,node,nndof,
     *     lnodetype,alocal,ndim,time,dtime,pnewdt,
     *     kstep,kinc,kmeshsweep,jmatyp,jgvblock,lsmooth)

      include 'aba_param.inc'

!     -------------------------------------------------------------------------

!     umeshmotion subroutine
      dimension ulocal(ndim)
      dimension alocal(ndim,*),time(2)
      dimension jmatyp(*),jgvblock(*)

!     getnodetoelemconn routine
      parameter (maxnelems = 100 )
      dimension jelemlist(maxnelems),jelemtype(maxnelems)

!     getvrmavgatnode routine
      dimension array(15)

!     getpartinfo routine
      character*80 partname
      character*80 cpname

!     -------------------------------------------------------------------------
!     size for exchange array
      parameter (iNodeNum = 10000) ! number of nodes in the model
!     common block used to exchange data between UMESHMOTION and UFIELD
      common /kExchData/ iNodeId(iNodeNum), rCslip(iNodeNum)
      save /kExchData/

      data iSubCall /1/ ! used to count number of sub. calls
      save iPrvInc      ! used to save previous increment number
!     -------------------------------------------------------------------------

!     find global node id
      jtyp = 0
      call GETPARTINFO(node, jtyp, partname, locnum, jrcd)
      if (jrcd /= 0) then
        write(*,*) 'Error 1'
        call xit
      end if

!     find node connectivity
      nelems = maxnelems
      call GETNODETOELEMCONN(locnum, nelems, jelemlist, jelemtype,
     *     jrcd, jgvblock)
      if (jrcd /= 0) then
        write(*,*) 'Error 2'
        call xit
      end if

!     get contact stress
      jtyp = 0
      call GETVRMAVGATNODE(locnum, jtyp, 'CSTRESS', array, jrcd,
     *     jelemlist, nelems, jmatyp, jgvblock)
      if (jrcd == 1 .and. array(1) /= 0.d0) then
        write(*,*) 'Error 3'
        call xit
      end if
      rCpress = array(1)

!     get contact displacement
      jtyp = 0
      call GETVRMAVGATNODE(locnum, jtyp , 'CDISP', array, jrcd,
     *     jelemlist, nelems, jmatyp, jgvblock)
      if (jrcd == 1 .and. array(2) /= 0.d0 .and. array(3) /= 0.0) then
        write(*,*) 'Error 4'
        call xit
      end if
      rCslipMag = sqrt(array(2)**2 + array(3)**2)

      if (kmeshsweep == 0) then

!       reset count if new increment
        if (kinc /= iPrvInc) iSubCall = 1

!       store node number
        iNodeId(iSubCall) = node
!       store cslip value
        rCslip(iSubCall) = rCslipMag
!       increment position in arrays
        iSubCall = iSubCall + 1
!       save increment number
        iPrvInc = kinc

!       check array size
        if (iSubCall > iNodeNum) then
          write(*,*) 'Error 5'
          call xit
        end if

        !write(*,*) iNodeId
        !write(*,*) rCslip

      end if

!     user defined wear factor
!     rFactor = 1.d0
!     h = abs(rFactor * rCpress * rCslipMag)
!     ulocal(ndim) = ulocal(ndim)-h
      ulocal(ndim) = 0.d0

      return
      end subroutine umeshmotion

!-------------------------------------------------------------------------------
!     UFIELD
!-------------------------------------------------------------------------------

      subroutine ufield(field,kfield,nsecpt,kstep,kinc,time,node,coords,
     *                  temp,dtemp,nfield)

      include 'aba_param.inc'

      dimension field(nsecpt,nfield),coords(3),time(2),temp(nsecpt),
     *          dtemp(nsecpt)

!     -------------------------------------------------------------------------
!     size for exchange array
      parameter (iNodeNum = 10000) ! number of nodes in the model
!     common block used to exchange data between UMESHMOTION and UFIELD
      common /kExchData/ iNodeId(iNodeNum), rCslip(iNodeNum)
      save /kExchData/
!     -------------------------------------------------------------------------

      ! loop over the array
      do k = 1, iNodeNum, 1
        if (iNodeId(k) == node) then
            !write(*,*) 'FIND: ', node, rCslip(k)
            field(nsecpt,nfield) = rCslip(k)
          exit
        else
          field(nsecpt,nfield) = 0.0
        end if
      end do

      return
      end subroutine ufield

!-------------------------------------EOF---------------------------------------
